MAXScript Extensions > MAXScript Extensions for Particle Flow > Particle Flow Classes > Operators > Shape >

# Shape_Facing : Helper

    Shape_Facing - superclass: helper super-superclass:node - classID: #(1962490641, 515064320)

Value > MAXWrapper > Node > Helper > Shape_Facing

| Particle Flow - Quick Navigation

Description:

The Shape_Facing operator creates each particle as a rectangle that always faces a particular object, camera, or direction. For effects like smoke, fire, water, bubbles, or snowflakes, use Shape_Facing with a material containing appropriate opacity and diffuse maps.

By default, the particles' top and bottom sides are parallel to the horizontal plane. The Orientation setting lets you change this default alignment.

Constructor:

    Shape_Facing...

Properties:

    <Shape_Facing>.Look_At_Object UndefinedClass default: undefined -- node

    <Shape_Facing>.Parallel BooleanClass default: false -- boolean

When False, all particles continuously rotate to stay facing toward the Look At object. Each particle's orientation varies because its location differs from those of the others.

When True, all particles face in the same direction, defined by an imaginary line between the Particle Source gizmo center and the Look At object.

    <Shape_Facing>.Size_Space Integer default: 0 -- integer

Use these settings to specify the coordinate system for setting the size, as well as the size parameters. The numeric settings in this group are not animatable.

0: In World Space - Sets the absolute size in system units, using the World coordinate system.

1: In Local Space - Sets particle size relative to the existing size, in local space. The software uses the dimensions of the existing shape to determine the size of the "facing rectangle"

2: In Screen Space - Sets the facing particles' size as a percentage of the screen width. The actual size of each particle changes as necessary throughout the animation, depending its distance from the camera, to maintain a constant size from the camera's point of view. This option is available only when the Look At object is a camera, and Use Parallel Direction is off.

    <Shape_Facing>.Units Float    default: 1.0 -- world units

When the 0: In World Space option is specified, sets the particle size in world units. Range is 0 to 1000000000.

    <Shape_Facing>.Inherited_Scale Float default:100.0 -- percentage;'Inherited Scale'

Sets the facing particles' size as a percentage of the existing size. Range is 0 to 100.

    <Shape_Facing>.Proportion Float default:1.0 -- percentage

Sets the particle size as a percentage of the screen width.

    <Shape_Facing>.variation Float    default: 0.0 -- percentage

Sets the percentage by which particle size can vary.

    <Shape_Facing>.Pivot_At Integer default: 1 -- integer

Specifies the part of the particle around which rotation is performed when maintaining the facing direction.

Possible values are:

0: Top - the center of the top side is used as the particle center for rotation

1: Center

2: Bottom - the center of the bottom side is used as the particle center for rotation

    <Shape_Facing>.WH_Ratio Float default:1.0 -- float

Defines the aspect (width-to-height) ratio of the shape rectangle.

    <Shape_Facing>.Orientation Integer default:0 -- integer

Get/Set the index of the Orientation drop-down list to choose how particles rotate on the axes not specified by the Look At direction.

0: Align to Horizon (default) - Keeps the top edge aligned with the horizon (the world XY plane).

1: Align to Speed Follow - Uses the right side of each particle as the leading edge, so the top and bottom edges are aligned with the direction of particle motion.

2: Random - Orients the top edge at random.

3: Allow Spinning - To spin the particles, choose this option, and in the same event use a Rotation Spin operator. In the latter, set Rotation Axis to Particle Space and use the default axis values: X=0, Y=0, Z=1.

    <Shape_Facing>.Random_Seed Integer default:12345 -- integer

Specifies the randomization value.

## shape_facing Interfaces:

The following Interfaces are exposed by the shape_facing Class:

Interface: action

Interface: operator

Interface: PViewItem

#### See Also

- Shape_Instance : Helper

- Shape_Mark : Helper

- Particle Flow Classes